/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/
#include "stdafx.h"
#include "crystalcpuid.h"
#include "CrystalCPUIDDlg.h"
#include "LoveHammerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CCrystalCPUIDDlg* P;

BYTE MultiTableMobileAthlon[32]={
	22, 23, 24, 25, 10, 11, 12, 13, 
	14, 15, 16, 17, 18, 19, 20, 21,
	 6, 38,  8, 40, 26, 27, 28, 42, 
	30, 44, 32, 33, 34, 36, 46, 48};

/* divide by 1000 to get VID. */
static int VoltageTableMobileAthlon[32] ={
	2000, 1950, 1900, 1850, 1800, 1750, 1700, 1650,
	1600, 1550, 1500, 1450, 1400, 1350, 1300,    0,
	1275, 1250, 1225, 1200, 1175, 1150, 1125, 1100,
	1075, 1050, 1025, 1000,  975,  950,  925,    0};

/////////////////////////////////////////////////////////////////////////////
// CLoveHammerDlg Dialog

CLoveHammerDlg::CLoveHammerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoveHammerDlg::IDD, pParent)
{
	P = (CCrystalCPUIDDlg*)pParent;
	//{{AFX_DATA_INIT(CLoveHammerDlg)
	m_CurrentFID = _T("");
	m_CurrentVID = _T("");
	m_MaxFID = _T("");
	m_MaxVID = _T("");
	m_StartupFID = _T("");
	m_StartupVID = _T("");
	m_EnableVoltage = FALSE;
	//}}AFX_DATA_INIT
}

void CLoveHammerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoveHammerDlg)
	DDX_Control(pDX, IDC_LH_HELP, m_Help);
	DDX_Control(pDX, IDC_LH_SET_VID, m_SetVID);
	DDX_Control(pDX, IDC_LH_SET_FID, m_SetFID);
	DDX_Text(pDX, IDC_LH_CURRENT_FID, m_CurrentFID);
	DDX_Text(pDX, IDC_LH_CURRENT_VID, m_CurrentVID);
	DDX_Text(pDX, IDC_LH_MAX_FID, m_MaxFID);
	DDX_Text(pDX, IDC_LH_MAX_VID, m_MaxVID);
	DDX_Text(pDX, IDC_LH_STARTUP_FID, m_StartupFID);
	DDX_Text(pDX, IDC_LH_STARTUP_VID, m_StartupVID);
	DDX_Check(pDX, IDC_LH_ENABLE_VOLTAGE, m_EnableVoltage);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLoveHammerDlg, CDialog)
	//{{AFX_MSG_MAP(CLoveHammerDlg)
	ON_CBN_SELCHANGE(IDC_LH_SET_FID, OnSelchangeLhSetFid)
	ON_BN_CLICKED(IDC_LH_CREATE_LINK, OnLhCreateLink)
	ON_CBN_SELCHANGE(IDC_LH_SET_VID, OnSelchangeLhSetVid)
	ON_BN_CLICKED(IDC_LH_ENABLE_VOLTAGE, OnLhEnableVoltage)
	ON_BN_CLICKED(IDC_LH_HELP, OnLhHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CLoveHammerDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CLoveHammerDlg::OnOK() 
{
	CDialog::OnOK();
}

void CLoveHammerDlg::Refresh()
{
	DWORD data;
	char str[256];

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);
	m_CurrentFID = P->SysInfo->GetInfo(LH_GET_CURRENT_MULTIPLIER,str);
	m_StartupFID = P->SysInfo->GetInfo(LH_GET_STARTUP_MULTIPLIER,str);
	m_MaxFID     = P->SysInfo->GetInfo(LH_GET_MAX_MULTIPLIER,str);
	m_CurrentVID = P->SysInfo->GetInfo(LH_GET_CURRENT_VOLTAGE,str);
	m_StartupVID = P->SysInfo->GetInfo(LH_GET_STARTUP_VOLTAGE,str);
	m_MaxVID     = P->SysInfo->GetInfo(LH_GET_MAX_VOLTAGE,str);

	UpdateData(FALSE);
	UpdateWindow();
}

BOOL CLoveHammerDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString cstr;
	double d;
	DWORD id = 0;
	DWORD data;

	// Init ComboBox
	P->SysInfo->GetData(LH_GET_TYPE, &m_type);
	if( m_type == 8 ){
		for(d = 4.0; d <= 25.0; d += 0.5){
			cstr.Format("x%.1f",d);
			m_SetFID.AddString(cstr);
		}
		for(d = 1.550; d >= 0.800; d -= 0.025){
			cstr.Format("%.3fV",d);
			m_SetVID.AddString(cstr);
		}
	}else if( m_type == 7 ){
		int i;
		for( i = 0; i < 32; i++ ){
			cstr.Format("x%.1f", MultiTableMobileAthlon[i] / 2.0 );
			m_SetFID.AddString(cstr);
		}
		for( i = 0; i < 31; i++ ){
			cstr.Format("%.3fV", VoltageTableMobileAthlon[i] / 1000.0 );
			m_SetVID.AddString(cstr);
		}
	}

	// Init Current Status
	P->SysInfo->GetData(LH_GET_CURRENT_STATUS, &data);

	P->SysInfo->GetData(LH_GET_CURRENT_FID,&id);
	m_SetFID.SetCurSel(id);
	P->SysInfo->GetData(LH_GET_CURRENT_VID,&id);
	m_SetVID.SetCurSel(id);

	m_SetVID.EnableWindow(FALSE);

	Refresh();

	return TRUE;
}

void CLoveHammerDlg::OnSelchangeLhSetFid() 
{
	P->SysInfo->SetData(LH_SET_FID,m_SetFID.GetCurSel());
	Refresh();
	P->Refresh(TRUE);
}

void CLoveHammerDlg::OnSelchangeLhSetVid() 
{
	P->SysInfo->SetData(LH_SET_VID,m_SetVID.GetCurSel());
	Refresh();
	P->Refresh(TRUE);
}

void CLoveHammerDlg::OnLhCreateLink() 
{
	UpdateData( TRUE );
	CString cstr,cstr1,cstr2;
	CString option;
	CString strobj;
	CString message;
	TCHAR buf[MAX_PATH];

	m_SetFID.GetLBText(m_SetFID.GetCurSel(),cstr1);
	m_SetVID.GetLBText(m_SetVID.GetCurSel(),cstr2);

	// Get Desktop Path
    LPMALLOC pMalloc;
    if(SUCCEEDED(SHGetMalloc(&pMalloc)))
    {
		LPITEMIDLIST pItemIDList;
		SHGetSpecialFolderLocation(
            m_hWnd,
            CSIDL_DESKTOP,
            &pItemIDList);

        SHGetPathFromIDList(pItemIDList,buf);

        pMalloc -> Free(pItemIDList);
        pMalloc -> Release();
    }

	if( m_EnableVoltage ){
		option.Format("/F%d /V%d /P%d /E", m_SetFID.GetCurSel(), m_SetVID.GetCurSel(), P->m_Mask + 1);
		strobj.Format("%s\\%s %s.lnk", buf, cstr1, cstr2);
	}else{
		option.Format("/F%d /P%d /E", m_SetFID.GetCurSel(), P->m_Mask + 1);
		strobj.Format("%s\\%s.lnk", buf, cstr1);
	}
	message.Format("\
Create Shurtchut!!\r\n\
%s",
option);

	IShellLink *pisl;  
	WORD str[MAX_PATH];
	HRESULT hr = ::CoInitialize(NULL);
	if (SUCCEEDED(hr))
	{
		hr = ::CoCreateInstance(CLSID_ShellLink,
			NULL, CLSCTX_INPROC_SERVER,
			IID_IShellLink, (void **)&pisl); 
		if (SUCCEEDED(hr)) 
		{
			char s[MAX_PATH];
			::GetModuleFileName(NULL, s, MAX_PATH);
			CString strObjectPath = s;

			hr = pisl->SetPath((const char *)strObjectPath);
			if (SUCCEEDED(hr)) 
			{
				IPersistFile *pipf; 
				hr = pisl->QueryInterface(IID_IPersistFile, 
					(void **)&pipf);
				if (SUCCEEDED(hr)) 
				{
					pisl->SetShowCmd(SW_SHOWMINIMIZED);
					pisl->SetArguments(option);

					MultiByteToWideChar(CP_ACP, 0,
						(const char *)strobj,
						-1, str, MAX_PATH);  
					hr = pipf->Save(str, TRUE);
					if (FAILED(hr)){
						AfxMessageBox("Create Shortcut Failure!!");
					}else{
						MessageBox(message);
					}
					pipf->Release();
				}
			}
			pisl->Release();
		}
		::CoUninitialize();
	}
}

void CLoveHammerDlg::OnLhEnableVoltage() 
{
	UpdateData( TRUE );
	m_SetVID.EnableWindow( m_EnableVoltage );
}

void CLoveHammerDlg::OnLhHelp() 
{

MessageBox("\
---------------------------------------------------------------\r\n\
 K8 Voltage\r\n\
---------------------------------------------------------------\r\n\
Core Voltage =\r\n\
Base Voltage (0.800V - 1.550V)\r\n\
+ RVO1 (0.000V - 0.175V)\r\n\
+ RVO2 (0.000V - 0.075V)\r\n\
=> 0.800V - 1.800V\r\n\
 - RVO = Ramp Voltage Offset\r\n\
 - RVO1/2 remains as it is.\r\n\
---------------------------------------------------------------\r\n\
 Command line Option\r\n\
---------------------------------------------------------------\r\n\
for general\r\n\
 /Q or -Q = Save as PNG image. (temp.png)\r\n\
 /S or -S = Save as Text. (temp.txt)\r\n\
 /Pxx or -Pxx = Select Processor (xx = 1-32)\r\n\
 /E or -E = Exit\r\n\
for K7/K8\r\n\
 /Fxx or -Fxx = Change Multiplier (xx = FID)\r\n\
 /Vxx or -Vxx = Change Voltage (xx = VID)\r\n\
");	

}
